
	;;
	;;	Helper macros to save going mad when typing in songs..
	;;
	;;	Use like..
	;;		PATT00:
	;;			LENGTH 4
	;;			NOTEON 3
	;;			NOTEON 7
	;;			NOTEON 6
	;;			PATTERNEND
	;;

	;;
	;;	Sequence Helpers..
	;;
	MAC STOP
		.byte $03+($3F<<2)
	ENDM

	MAC GOTO
		.byte $03+({1}<<2)
	ENDM

	MAC PATTERN
		.byte $00+({1}<<2)
	ENDM

	MAC TRANSPOSE
		.byte $01+({1}<<2)
	ENDM

	;;
	;;	Pattern Helpers
	;;
	MAC NOTEON
		.byte $00+({1}<<3)
	ENDM

	MAC NOTEOFF
		.byte $01+({1}<<3)
	ENDM

	MAC LENGTH
		.byte $02+({1}<<3)
	ENDM

	MAC PATCH
		.byte $03+({1}<<3)
	ENDM

	MAC REST
		.byte $04+({1}<<3)
	ENDM

	MAC VOLUME
		.byte $05+({1}<<3)
	ENDM

	MAC PATTERNEND
		.byte $07
	ENDM

;;
;;	Translate 5 bit length into a real frame time to wait..
;;
NoteLengthLUT	.byte 16,32,48,64,80,96,112,128

;;	ARP_00 is the default no arpeggio. When we have arp switched off we are actually using this..
;;		1st byte is the mask.. This must be a ^2-1
;;		then mask+1 bytes of transpose offsets...
;;
;;	Tables of Arpeggio data..
;;	
ARP_BASE:
			;;
			;;	No arpeggio..
			;;
ARP_00		= *-ARP_BASE
			.byte 0
			.byte 0
			;;
			;;	Simple +1 octave arpeggio..
			;;
ARP_01		= *-ARP_BASE
			.byte 1
			.byte 0,12
			;;
			;;	Simple +1 octave arpeggio..
			;;
ARP_02		= *-ARP_BASE
			.byte 7
			.byte 0,0,-1,-1,0,0,1,1

;;
;;	Table of Patches, 16 bytes each..
;;
Patches:
		;;
		;;	00	-	Bass Patch..
		;;
		.byte $80		; PulseWidth
		.byte 0			; Transpose
		.byte ARP_00	; Arpeggio Offset
		.byte $f0		; Attack Rate
		.byte $60		; Attack Level
		.byte $10		; Decay Rate
		.byte $30		; Sustain level
		.byte $02		; Release Rate
		.byte 0,0,0,0,0,0,0,0			; Padding to 16 bytes
		;;
		;;	01	-	Octave Warbler..
		;;
		.byte $80		; PulseWidth
		.byte 0			; Transpose
		.byte ARP_01	; Arpeggio Offset
		.byte $80		; Attack Rate
		.byte $50		; Attack Level
		.byte $04		; Decay Rate
		.byte $40		; Sustain level
		.byte $08		; Release Rate
		.byte 0,0,0,0,0,0,0,0			; Padding to 16 bytes
		;;
		;;	02	-	Lead line..
		;;
		.byte $80		; PulseWidth
		.byte 0			; Transpose
		.byte ARP_00	; Arpeggio Offset
		.byte $f0		; Attack Rate
		.byte $40		; Attack Level
		.byte $10		; Decay Rate
		.byte $40		; Sustain level
		.byte $10		; Release Rate
		.byte 0,0,0,0,0,0,0,0		; Padding to 16 bytes
		;;
		;;	03	-	Drum test..
		;;
		.byte $20		; PulseWidth
		.byte 0			; Transpose
		.byte ARP_02	; Arpeggio Offset
		.byte $f0		; Attack Rate
		.byte $ff		; Attack Level
		.byte $40		; Decay Rate
		.byte $00		; Sustain level
		.byte $00		; Release Rate
		ds.b 8			; Padding to 16 bytes

;;
;;	*ptr to song data for each voice for each song.. Three words per song entry..
;;
Songs:
		;;	Song 0 - Monty on the Run knock off..
		.word TESTSONG00_0,TESTSONG00_1,TESTSONG00_2
		;;	Song 1 - Pattern test..
		.word TESTSONG01_0,TESTSONG00_STOP,TESTSONG00_STOP

;;
;;	Table of pointers to the available patterns..
;;
Patterns_Lo		.byte <PATT0
				.byte <PATT1
				.byte <PATT2
				.byte <PATT3

Patterns_Hi		.byte >PATT0
				.byte >PATT1
				.byte >PATT2
				.byte >PATT3

;;	
;;	The actual patterns themselves..
;;
		;;
		;;	PATT 0,1,2	are the Auf Wiedersehen Monty type tester'a'rooni.. Well as much as a programmer can do anyway :)
		;;
PATT0:
		PATCH 1
;		LENGTH 0
		NOTEON 3		;D#5
		NOTEON 8		;G#5
		NOTEON 10		;A#5
		NOTEON 8		;G#5
		NOTEON 3+12		;D#6
		NOTEON 8		;G#5
		NOTEON 10		;A#5
		NOTEON 8		;G#5
		PATTERNEND

PATT1:
		PATCH 0
;		LENGTH 0
		NOTEON 8		;G#2
		NOTEOFF 0		;G#2
		NOTEOFF 0		;NOTEON 11+12	;B 3
		NOTEON 8		;G#2
		NOTEON 8		;G#2
		NOTEON 8		;G#2
		NOTEOFF 0		;NOTEON 11+12	;B 3
		NOTEON 3		;D#2
		PATTERNEND

PATT2:
		PATCH 2
;		LENGTH 0
		NOTEON 0		;C 5
		REST 0
		REST 0
		REST 0
		REST 0
		REST 0
		REST 0
		REST 0
		PATTERNEND

PATT3:
		PATCH 3
		LENGTH 0
		NOTEON 0		;C 5
		NOTEON 0		;C 5
		NOTEON 0		;C 5
		NOTEON 0		;C 5
		NOTEON 0		;C 5
		NOTEON 0		;C 5
		NOTEON 0		;C 5
		NOTEON 0		;C 5
		PATTERNEND

;;	Test song pattern sequences..
TESTSONG00_0:
		TRANSPOSE 24+12
		PATTERN 0
		PATTERN 0
		TRANSPOSE 21+12
		PATTERN 0
		PATTERN 0
		TRANSPOSE 17+12
		PATTERN 0
		PATTERN 0
		TRANSPOSE 19+12
		PATTERN 0
		PATTERN 0
		TRANSPOSE 24+12
		PATTERN 0
		PATTERN 0
		TRANSPOSE 21+12
		PATTERN 0
		PATTERN 0
		TRANSPOSE 17+12
		PATTERN 0
		PATTERN 0
		TRANSPOSE 19+12
		PATTERN 0
		PATTERN 0
		STOP

TESTSONG00_1:
		TRANSPOSE 12
		PATTERN 1
		PATTERN 1
		TRANSPOSE 9
		PATTERN 1
		PATTERN 1
		TRANSPOSE 5
		PATTERN 1
		PATTERN 1
		TRANSPOSE 7
		PATTERN 1
		PATTERN 1
		TRANSPOSE 12
		PATTERN 1
		PATTERN 1
		TRANSPOSE 9
		PATTERN 1
		PATTERN 1
		TRANSPOSE 5
		PATTERN 1
		PATTERN 1
		TRANSPOSE 7
		PATTERN 1
		PATTERN 1
		STOP

TESTSONG00_2:
		TRANSPOSE 36+12
		PATTERN 2
		PATTERN 2
		TRANSPOSE 36+9
		PATTERN 2
		PATTERN 2
		TRANSPOSE 36+5
		PATTERN 2
		PATTERN 2
		TRANSPOSE 36+7
		PATTERN 2
		PATTERN 2
		TRANSPOSE 36+12
		PATTERN 2
		PATTERN 2
		TRANSPOSE 36+9
		PATTERN 2
		PATTERN 2
		TRANSPOSE 36+5
		PATTERN 2
		PATTERN 2
		TRANSPOSE 36+7
		PATTERN 2
		PATTERN 2
		STOP




TESTSONG01_0:
		TRANSPOSE 0
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		PATTERN 3
		STOP








TESTSONG00_STOP:
		stop